package com.qgs.dc.s7.my.s7connector.enmuc;

import com.qgs.dc.s7.my.s7connector.api.DaveArea;
import com.qgs.dc.s7.my.s7connector.type.PlcVar;
import com.qgs.dc.s7.my.s7connector.type.TransportSize;
import org.omg.CORBA.PRIVATE_MEMBER;

//实际 Plc中的变量。。。  要实现录入到这个枚举类中。。。 为后续做准备。
public enum PlcVarActual {
    HeartBeat("HeartBeat",PlcVar.BOOL,1,DaveArea.DB,3,3267,5),
    //bitOffset 是针对Bool 来说的，
    DB54("DB54",PlcVar.BYTE,1,DaveArea.DB,3,3268,0),
    DTL("DTL",PlcVar.DTL,1,DaveArea.DB,3,44,0),
    STRING1("STRING",PlcVar.STRING,1,DaveArea.DB,3,62,0),

    CharArrays("CharArrays",PlcVar.CHAR_Array,2,DaveArea.DB,3,834,0),
    BooleanArrays("BooleanArrays",PlcVar.BOOL_Array,2,DaveArea.DB,3,830,0)



    ;

    private String name;
    private DaveArea area;
    private Integer areaNumber;
    private Integer byteOffset;
    private Integer bitOffset;
    private PlcVar type;
    //length = 1代表 非数组;;;       length > 1 代表数组  ;; 注意 length这个参数 是实际plc中 数据的长度，和read操作相关
    //如果是String 类型不用填length 只需要填string类型的起始位置就行了，我会自己去取数据长度（也就是说这里的length并不是string 的长度）。
    private Integer length;

    PlcVarActual(String name, PlcVar type,Integer length, DaveArea area, Integer areaNumber, Integer byteOffset, Integer bitOffset){
        this.name = name;
        this.type = type;
        this.length = length;
        this.area = area;
        this.areaNumber = areaNumber;
        this.byteOffset = byteOffset;
        this.bitOffset = bitOffset;
    }


    public String getName() {
        return name;
    }

    public DaveArea getArea() {
        return area;
    }

    public Integer getAreaNumber() {
        return areaNumber;
    }

    public Integer getBitOffset() {
        return bitOffset;
    }

    public Integer getByteOffset() {
        return byteOffset;
    }

    public PlcVar getType() {
        return type;
    }

    public Integer getLength() {
        return length;
    }
}
